<template>
    <div>
        This page is secured and only visible for admin.
        The content itself depends on the admin permission (on the server side)

        <p>
            Sensible content : {{ sensibleInformation}}
        </p>

        <ul style="margin-bottom: 50px;margin-top: 50px">
            <li><router-link to="/secured">Return to secured page for standard user</router-link></li>
            <li><a href="#" @click.prevent="impersonate('user')">Impersonate user "user"</a></li>
            <li><a href="#" @click.prevent="impersonate('moderator')">Impersonate user "moderator"</a></li>
            <li><a href="#" @click.prevent="logout">Logout</a></li>
        </ul>


<pre>
Current user :
{{currentUser}}
</pre>

    </div>
</template>

<script setup lang="ts">
definePageMeta({
    middleware: ["auth"],
    roles: ["ROLE_ADMIN"]
})
</script>

<script lang="ts">
import {useAuth} from "~/store/auth.store";

export default {
    data() {
        return {
            sensibleInformation: ''
        }
    },
    computed: {
        currentUser() {
            const store = useAuth();
            return store.state.user;
        }
    },

    async mounted() {
        // It should be possible to create a global instance of axios that populate this header automatically
        let response = await useSecuredGetAxios('http://dev.malt.fr/api/secured/admin');

        // FIXME useFetch is recommended but not working yet. There is no call to the server... ??
        // const store = useAuth();
        // let response = await useFetch('http://dev.malt.fr/api/secured/admin' , {method : 'get', headers : store.authHeader() });
        this.sensibleInformation  = response.data;
    },
    methods: {
        logout() {
            const store = useAuth();
            store.logout();
        },
        impersonate(user: string) {
            const store = useAuth();
            store.impersonate(user);
        }
    }
}

</script>
